XChaCha20Poly1305_Base Class Referenceabstract

IETF XChaCha20Poly1305 cipher base implementation. More...

`#include <chachapoly.h>`

Inheritance diagram for XChaCha20Poly1305_Base:

## Public Member Functions

std::string | AlgorithmName () const
| Provides the name of this algorithm.
std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm.
size_t | MinKeyLength () const
| Returns smallest valid key length.
size_t | MaxKeyLength () const
| Returns largest valid key length.
size_t | DefaultKeyLength () const
| Returns default key length.
size_t | GetValidKeyLength (size_t n) const
| Returns a valid key length for the algorithm.
bool | IsValidKeyLength (size_t n) const
| Returns whether keylength is a valid key length.
unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance.
IV_Requirement | IVRequirement () const
| Minimal requirement for secure IVs.
unsigned int | IVSize () const
| Returns length of the IV accepted by this object.
unsigned int | MinIVLength () const
| Provides the minimum size of an IV.
unsigned int | MaxIVLength () const
| Provides the maximum size of an IV.
unsigned int | DigestSize () const
| Provides the digest size of the hash.
lword | MaxHeaderLength () const
| Provides the maximum length of AAD that can be input.
lword | MaxMessageLength () const
| Provides the maximum length of encrypted data.
lword | MaxFooterLength () const
| Provides the maximum length of AAD.
virtual void | EncryptAndAuthenticate (byte *ciphertext, byte *mac, size_t macSize, const byte *iv, int ivLength, const byte *aad, size_t aadLength, const byte *message, size_t messageLength)
| Encrypts and calculates a MAC in one call.
virtual bool | DecryptAndVerify (byte *message, const byte *mac, size_t macSize, const byte *iv, int ivLength, const byte *aad, size_t aadLength, const byte *ciphertext, size_t ciphertextLength)
| Decrypts and verifies a MAC in one call.
Public Member Functions inherited from AuthenticatedSymmetricCipherBase
bool | IsRandomAccess () const
| Determines whether the cipher supports random access.
bool | IsSelfInverting () const
| Determines whether the cipher is self-inverting.
void | SetKey (const byte *userKey, size_t keylength, const NameValuePairs &params)
| Sets or reset the key of this object.
void | Restart ()
| Restart the hash.
void | Resynchronize (const byte *iv, int length=-1)
| Resynchronize with an IV.
void | Update (const byte *input, size_t length)
| Updates a hash with additional input.
void | ProcessData (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt an array of bytes.
void | TruncatedFinal (byte *mac, size_t macSize)
| Computes the hash of the current message.
Public Member Functions inherited from AuthenticatedSymmetricCipher
virtual bool | NeedsPrespecifiedDataLengths () const
| Determines if data lengths must be specified prior to inputting data.
void | SpecifyDataLengths (lword headerLength, lword messageLength, lword footerLength=0)
| Prescribes the data lengths.
Public Member Functions inherited from SimpleKeyingInterface
void | SetKeyWithRounds (const byte *key, size_t length, int rounds)
| Sets or reset the key of this object.
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv, size_t ivLength)
| Sets or reset the key of this object.
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv)
| Sets or reset the key of this object.
bool | IsResynchronizable () const
| Determines if the object can be resynchronized.
bool | CanUseRandomIVs () const
| Determines if the object can use random IVs.
bool | CanUsePredictableIVs () const
| Determines if the object can use random but possibly predictable IVs.
bool | CanUseStructuredIVs () const
| Determines if the object can use structured IVs.
unsigned int | DefaultIVLength () const
| Provides the default size of an IV.
virtual void | GetNextIV (RandomNumberGenerator &rng, byte *iv)
| Retrieves a secure IV for the next message.
Public Member Functions inherited from HashTransformation
HashTransformation & | Ref ()
| Provides a reference to this object.
virtual byte * | CreateUpdateSpace (size_t &size)
| Request space which can be written into by the caller.
virtual void | Final (byte *digest)
| Computes the hash of the current message.
unsigned int | TagSize () const
| Provides the tag size of the hash.
virtual unsigned int | BlockSize () const
| Provides the block size of the compression function.
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this hash.
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message.
virtual bool | Verify (const byte *digest)
| Verifies the hash of the current message.
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message.
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message.
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| Verifies the hash of the current message.
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message.
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms.
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object.
Public Member Functions inherited from StreamTransformation
StreamTransformation & | Ref ()
| Provides a reference to this object.
virtual unsigned int | MandatoryBlockSize () const
| Provides the mandatory block size of the cipher.
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this cipher.
virtual unsigned int | GetOptimalBlockSizeUsed () const
| Provides the number of bytes used in the current block when processing at optimal block size.
virtual size_t | ProcessLastBlock (byte *outString, size_t outLength, const byte *inString, size_t inLength)
| Encrypt or decrypt the last block of data.
virtual unsigned int | MinLastBlockSize () const
| Provides the size of the last block.
virtual bool | IsLastBlockSpecial () const
| Determines if the last block receives special processing.
void | ProcessString (byte *inoutString, size_t length)
| Encrypt or decrypt a string of bytes.
void | ProcessString (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt a string of bytes.
byte | ProcessByte (byte input)
| Encrypt or decrypt a byte.
virtual void | Seek (lword pos)
| Seek to an absolute position.
virtual bool | IsForwardTransformation () const =0
| Determines if the cipher is being operated in its forward direction.

## Static Public Member Functions

static const char * | StaticAlgorithmName ()

## Additional Inherited Members

Public Types inherited from SimpleKeyingInterface
enum | IV_Requirement { UNIQUE_IV = 0 , RANDOM_IV , UNPREDICTABLE_RANDOM_IV , INTERNALLY_GENERATED_IV , NOT_RESYNCHRONIZABLE }
| Secure IVs requirements as enumerated values. More...

## Detailed Description

IETF XChaCha20Poly1305 cipher base implementation.

Base implementation of the AuthenticatedSymmetricCipher interface

Since
  Crypto++ 8.1

Definition at line 177 of file chachapoly.h.

## Constructor & Destructor Documentation

## ~XChaCha20Poly1305_Base()

virtual XChaCha20Poly1305_Base::~XChaCha20Poly1305_Base | ( |  | ) |

inline virtual

Definition at line 183 of file chachapoly.h.

## Member Function Documentation

## StaticAlgorithmName()

static const char * XChaCha20Poly1305_Base::StaticAlgorithmName | ( |  | ) |

inline static

Definition at line 180 of file chachapoly.h.

## AlgorithmName()

std::string XChaCha20Poly1305_Base::AlgorithmName | ( |  | ) | const

inline virtual

Provides the name of this algorithm.

Returns
  the standard algorithm name

The standard algorithm name can be a name like AES or AES/GCM. Some algorithms do not have standard names yet. For example, there is no standard algorithm name for Shoup's ECIES.

Reimplemented from AuthenticatedSymmetricCipher.

Definition at line 186 of file chachapoly.h.

## AlgorithmProvider()

std::string XChaCha20Poly1305_Base::AlgorithmProvider | ( |  | ) | const

inline virtual

Retrieve the provider of this algorithm.

Returns
  the algorithm provider

The algorithm provider can be a name like "C++", "SSE", "NEON", "AESNI", "ARMv8" and "Power8". C++ is standard C++ code. Other labels, like SSE, usually indicate a specialized implementation using instructions from a higher instruction set architecture (ISA). Future labels may include external hardware like a hardware security module (HSM).

Generally speaking Wei Dai's original IA-32 ASM code falls under "SSE2". Labels like "SSSE3" and "SSE4.1" follow after Wei's code and use intrinsics instead of ASM.

Algorithms which combine different instructions or ISAs provide the dominant one. For example on x86 `AES/GCM` returns "AESNI" rather than "CLMUL" or "AES+SSE4.1" or "AES+CLMUL" or "AES+SSE4.1+CLMUL".

Note
  Provider is not universally implemented yet.

Since
  Crypto++ 8.0

Reimplemented from AuthenticatedSymmetricCipher.

Definition at line 188 of file chachapoly.h.

## MinKeyLength()

size_t XChaCha20Poly1305_Base::MinKeyLength | ( |  | ) | const

inline virtual

Returns smallest valid key length.

Returns
  the minimum key length, in bytes

Implements SimpleKeyingInterface.

Definition at line 190 of file chachapoly.h.

## MaxKeyLength()

size_t XChaCha20Poly1305_Base::MaxKeyLength | ( |  | ) | const

inline virtual

Returns largest valid key length.

Returns
  the maximum key length, in bytes

Implements SimpleKeyingInterface.

Definition at line 192 of file chachapoly.h.

## DefaultKeyLength()

size_t XChaCha20Poly1305_Base::DefaultKeyLength | ( |  | ) | const

inline virtual

Returns default key length.

Returns
  the default key length, in bytes

Implements SimpleKeyingInterface.

Definition at line 194 of file chachapoly.h.

## GetValidKeyLength()

size_t XChaCha20Poly1305_Base::GetValidKeyLength | ( | size_t | keylength | ) | const

inline virtual

Returns a valid key length for the algorithm.

Parameters

  keylength | the size of the key, in bytes

Returns
  the valid key length, in bytes

keylength is provided in bytes, not bits. If keylength is less than MIN_KEYLENGTH, then the function returns MIN_KEYLENGTH. If keylength is greater than MAX_KEYLENGTH, then the function returns MAX_KEYLENGTH. if If keylength is a multiple of KEYLENGTH_MULTIPLE, then keylength is returned. Otherwise, the function returns a lower multiple of KEYLENGTH_MULTIPLE.

Implements SimpleKeyingInterface.

Definition at line 196 of file chachapoly.h.

## IsValidKeyLength()

bool XChaCha20Poly1305_Base::IsValidKeyLength | ( | size_t | keylength | ) | const

inline virtual

Returns whether keylength is a valid key length.

Parameters

  keylength | the requested keylength

Returns
  true if keylength is valid, false otherwise

Internally the function calls GetValidKeyLength()

Reimplemented from SimpleKeyingInterface.

Definition at line 198 of file chachapoly.h.

## OptimalDataAlignment()

unsigned int XChaCha20Poly1305_Base::OptimalDataAlignment | ( |  | ) | const

inline virtual

Provides input and output data alignment for optimal performance.

Returns
  the input data alignment that provides optimal performance

See also
  GetAlignment() and OptimalBlockSize()

Reimplemented from HashTransformation.

Definition at line 200 of file chachapoly.h.

## IVRequirement()

IV_Requirement XChaCha20Poly1305_Base::IVRequirement | ( |  | ) | const

inline virtual

Minimal requirement for secure IVs.

Returns
  the secure IV requirement of the algorithm

Implements SimpleKeyingInterface.

Definition at line 202 of file chachapoly.h.

## IVSize()

unsigned int XChaCha20Poly1305_Base::IVSize | ( |  | ) | const

inline virtual

Returns length of the IV accepted by this object.

Returns
  the size of an IV, in bytes

Exceptions

  NotImplemented() | if the object does not support resynchronization

The default implementation throws NotImplemented

Reimplemented from SimpleKeyingInterface.

Definition at line 204 of file chachapoly.h.

## MinIVLength()

unsigned int XChaCha20Poly1305_Base::MinIVLength | ( |  | ) | const

inline virtual

Provides the minimum size of an IV.

Returns
  minimal length of IVs accepted by this object, in bytes

Exceptions

  NotImplemented() | if the object does not support resynchronization

Reimplemented from SimpleKeyingInterface.

Definition at line 206 of file chachapoly.h.

## MaxIVLength()

unsigned int XChaCha20Poly1305_Base::MaxIVLength | ( |  | ) | const

inline virtual

Provides the maximum size of an IV.

Returns
  maximal length of IVs accepted by this object, in bytes

Exceptions

  NotImplemented() | if the object does not support resynchronization

Reimplemented from SimpleKeyingInterface.

Definition at line 208 of file chachapoly.h.

## DigestSize()

unsigned int XChaCha20Poly1305_Base::DigestSize | ( |  | ) | const

inline virtual

Provides the digest size of the hash.

Returns
  the digest size of the hash.

Implements HashTransformation.

Definition at line 210 of file chachapoly.h.

## MaxHeaderLength()

lword XChaCha20Poly1305_Base::MaxHeaderLength | ( |  | ) | const

inline virtual

Provides the maximum length of AAD that can be input.

Returns
  the maximum length of AAD that can be input before the encrypted data

Implements AuthenticatedSymmetricCipher.

Definition at line 212 of file chachapoly.h.

## MaxMessageLength()

lword XChaCha20Poly1305_Base::MaxMessageLength | ( |  | ) | const

inline virtual

Provides the maximum length of encrypted data.

Returns
  the maximum length of encrypted data

Implements AuthenticatedSymmetricCipher.

Definition at line 214 of file chachapoly.h.

## MaxFooterLength()

lword XChaCha20Poly1305_Base::MaxFooterLength | ( |  | ) | const

inline virtual

Provides the maximum length of AAD.

Returns
  the maximum length of AAD that can be input after the encrypted data

Reimplemented from AuthenticatedSymmetricCipher.

Definition at line 216 of file chachapoly.h.

## EncryptAndAuthenticate()

void XChaCha20Poly1305_Base::EncryptAndAuthenticate | ( | byte * | ciphertext,
|  | byte * | mac,
|  | size_t | macSize,
|  | const byte * | iv,
|  | int | ivLength,
|  | const byte * | aad,
|  | size_t | aadLength,
|  | const byte * | message,
|  | size_t | messageLength
| ) |  |

virtual

Encrypts and calculates a MAC in one call.

Parameters

  ciphertext | the encryption buffer
  mac | the mac buffer
  macSize | the size of the MAC buffer, in bytes
  iv | the iv buffer
  ivLength | the size of the IV buffer, in bytes
  aad | the AAD buffer
  aadLength | the size of the AAD buffer, in bytes
  message | the message buffer
  messageLength | the size of the messagetext buffer, in bytes

EncryptAndAuthenticate() encrypts and generates the MAC in one call. The function truncates the MAC if `macSize < TagSize()`.

Reimplemented from AuthenticatedSymmetricCipher.

Definition at line 195 of file chachapoly.cpp.

## DecryptAndVerify()

bool XChaCha20Poly1305_Base::DecryptAndVerify | ( | byte * | message,
|  | const byte * | mac,
|  | size_t | macSize,
|  | const byte * | iv,
|  | int | ivLength,
|  | const byte * | aad,
|  | size_t | aadLength,
|  | const byte * | ciphertext,
|  | size_t | ciphertextLength
| ) |  |

virtual

Decrypts and verifies a MAC in one call.

Parameters

  message | the decryption buffer
  mac | the mac buffer
  macSize | the size of the MAC buffer, in bytes
  iv | the iv buffer
  ivLength | the size of the IV buffer, in bytes
  aad | the AAD buffer
  aadLength | the size of the AAD buffer, in bytes
  ciphertext | the cipher buffer
  ciphertextLength | the size of the ciphertext buffer, in bytes

Returns
  true if the MAC is valid and the decoding succeeded, false otherwise

DecryptAndVerify() decrypts and verifies the MAC in one call. `message` is a decryption buffer and should be at least as large as the ciphertext buffer.

The function returns true iff MAC is valid. DecryptAndVerify() assumes the MAC is truncated if `macLength < TagSize()`.

Reimplemented from AuthenticatedSymmetricCipher.

Definition at line 203 of file chachapoly.cpp.

The documentation for this class was generated from the following files:

- chachapoly.h
- chachapoly.cpp